/*

dummy setup.exe to launch msi

created by : zlel
last edit  : 2011/02/02 18:29:49
license    : public domain

Compile under mingw with
    mingw32-gcc -o setup.exe setup.c -mwindows

*/

#include <windows.h>

DWORD CreateProcessEx ( LPCSTR lpAppPath, LPCSTR lpCmdLine, BOOL bWaitForProcess);

int WINAPI WinMain(HINSTANCE hInstance , HINSTANCE hPrevInstance , PSTR lpCmdLine , int nCmdShow)
{
    PROCESS_INFORMATION ps;
	static STARTUPINFO si;
    BOOL res;
    int commandlength;
    char *commandline, *parameters, c, *myini;
    int quoted, i, found;
    char prefix[]="cmd /c ";
    char apppath[1024]="";
    char cmd[1024]="";
    char runcmd[1034]="";
    char inipath[1024]="";
    char *execname;
    char *execnamebuffer;
    char *cp;
    int j;
    int retval;

    commandlength = strlen(GetCommandLine());
    commandline = malloc(sizeof(char) * commandlength + 1);
    execnamebuffer = malloc(sizeof(char) * commandlength + 1);
    myini = malloc(sizeof(char) * commandlength + 1 + strlen(prefix) + 1);
    strcpy(commandline, GetCommandLine());
    strcpy(execnamebuffer, GetCommandLine());

    j=GetModuleFileName(NULL, apppath, 1024);
    for (cp=apppath+j; *cp!='\\' && cp>apppath; cp--);
    cp[0] = 0;
    chdir(apppath);

    execname = (char *) (execnamebuffer + (int) strlen(execnamebuffer));
    while ((execname > execnamebuffer) && (*(execname-1) != '\\')) execname--;
    for (j=0; ((execname+j)<(execnamebuffer+strlen(execnamebuffer))) && (*(execname+j) != '.'); j++) {};
    if (*(execname+j)=='.') {
        *(execname+j) = '\0';
    }

    sprintf(inipath, "%s\\%s.ini", apppath, execname);
    GetPrivateProfileString("setup", "run", "", cmd,  1024, inipath);

    if (0==strcmp(cmd, "")) {
        sprintf(inipath, "%s\\setup.ini", apppath);
        GetPrivateProfileString("setup", "run", "", cmd,  1024, inipath);
    }

    quoted = 0;
    found = 0;

    for (i=0; i<strlen(commandline) && 0==found; i++) {
        parameters = commandline + i;
        c = parameters[0];
        if (c == '"') quoted = 1 - quoted;
        if (c == ' ' && quoted==0) found = 1;
    }

    sprintf(myini, "%s %s", prefix, parameters);
    
    si.dwFlags = STARTF_USESHOWWINDOW;
    si.wShowWindow = SW_HIDE;

    while (parameters[0]==' ') parameters++;

    retval = 0;
    if (0==strcmp(cmd, "")) {
        sprintf(runcmd, "Initialization file %s.ini (or setup.ini) needs to contain RUN value under SETUP section.\n", execname);
        MessageBox(NULL , TEXT(runcmd) , TEXT("setup") , MB_OK);
    } else {
        sprintf(runcmd, "%s %s", prefix, cmd);
        // if (!CreateProcess(NULL, runcmd, NULL, NULL, FALSE, 0, NULL, apppath, &si, &ps)) {
        if (CreateProcessEx(apppath, runcmd, TRUE)) {
            // Keep silent
            // MessageBox(NULL , TEXT("Execution error.") , TEXT("setup") , MB_OK);
            printf("Execution error.\n");
            retval = 1;
        }
    }

    free(myini);
    free(commandline);
    free(execname);
    exit(retval);
}

DWORD CreateProcessEx ( LPCSTR lpAppPath, LPCSTR lpCmdLine, BOOL bWaitForProcess) {

    STARTUPINFO startupInfo;
    PROCESS_INFORMATION    processInformation;    

    char szAppPath    [ _MAX_PATH  ];
    char szCmdLine    [ _MAX_PATH  ];
    char drive        [ _MAX_DRIVE ];
    char dir        [ _MAX_DIR   ];
    char name       [ _MAX_FNAME ];
    char ext        [ _MAX_EXT ];

    szAppPath[ 0 ] = '\0';
    szCmdLine[ 0 ] = '\0';
    
    ZeroMemory( &startupInfo, sizeof( STARTUPINFO ));

    startupInfo.cb = sizeof( STARTUPINFO );

    ZeroMemory( &processInformation, sizeof( PROCESS_INFORMATION ));

    strcpy( szCmdLine, lpCmdLine );
    strcpy( szAppPath, lpAppPath );

    DWORD dwExitCode = -1;
   
    startupInfo.dwFlags = STARTF_USESHOWWINDOW;
    startupInfo.wShowWindow = SW_HIDE;

    if ( CreateProcess(NULL, szCmdLine, NULL, NULL, FALSE, 0, NULL, lpAppPath, &startupInfo, &processInformation)) {
 // if (!CreateProcess(NULL, runcmd, NULL, NULL, FALSE, 0, NULL, apppath, &si, &ps)) {

        if ( bWaitForProcess ) {
            WaitForSingleObject( processInformation.hProcess, INFINITE );
            GetExitCodeProcess( processInformation.hProcess, &dwExitCode );
        }
        else {

            CloseHandle( processInformation.hThread );
            CloseHandle( processInformation.hProcess );

            dwExitCode = 0;
        }
    }

    return dwExitCode;
}
